import 'package:flutter/material.dart';

class WMHSegement extends StatefulWidget {
  final Color appbarColor;//导航栏颜色
  final Widget leadingWidget;//左控件
  final List<Map> paramPages;
  final Color itemColor;//显示标题的颜色
  final Color itemBackgroundColor;//item背景颜色
  final Color indicateColor;//下划线颜色
  final double itemTitleFont;//显示标题大小
  final Color selectedColor;//当前项颜色
  final Color unSelectColor;//未选中项颜色
  final double indicatorHeight;//选中条高度
  final bool haveSeperateLine;//是否有分割线
  final List<Widget> bottomViewArr;//子视图
  final bool haveCommonVIew;//是否有共有视图
  final Widget commonWidget;//共有视图
  bool titleCanScroll = true;//标题栏能否滑动
  final Widget titleWidget;
  final TabController tabController;
  final Widget commonWidgetUp;
  final bool haveUpview;
  final double upViewHeight;

  WMHSegement({
    @required this.appbarColor,
    @required this.leadingWidget,
    @required this.paramPages,
    @required this.itemColor,
    @required this.itemBackgroundColor,
    @required this.indicateColor,
    @required this.itemTitleFont,
    @required this.selectedColor,
    @required this.unSelectColor,
    @required this.indicatorHeight,
    @required this.haveSeperateLine,
    @required this.bottomViewArr,
    @required this.titleWidget,
    @required this.haveCommonVIew,
    @required this.commonWidget,
    @required this.tabController,
    @required this.commonWidgetUp,
    @required this.haveUpview,
    @required this.upViewHeight,
  });

  WMHSegementState createState() => WMHSegementState();
}

class WMHSegementState extends State<WMHSegement> with SingleTickerProviderStateMixin {
  int currentIndex = 0;

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
  }

  @override
  void dispose() {
    // TODO: implement dispose
    super.dispose();
    widget.tabController.dispose();
  }

  @override
  Widget build(BuildContext context) {
    double bodyHeight = widget.haveUpview == true ? widget.upViewHeight + 44 : 44;

    // TODO: implement build
    return Scaffold(
      appBar: AppBar(
        elevation: 0,
        backgroundColor: widget.appbarColor,
        title: widget.titleWidget,
        leading: widget.leadingWidget,
        bottom: PreferredSize(
          child: _configureBodyView(),
          preferredSize: Size(MediaQuery.of(context).size.width, bodyHeight),
        ),
      ),
      body: Container(
        child: Column(
          children: <Widget>[
            widget.haveSeperateLine == true ? Container(
              child: Divider(height: 0.5),
            ) : Container(width: 0.0, height: 0.0),
            widget.haveCommonVIew == true ? widget.commonWidget : Container(width: 0.0, height: 0.0),
            Expanded(
              child: new TabBarView(
                controller: widget.tabController,
                children: widget.bottomViewArr,
              ),
            ),
          ],
        ),
      ),
    );
  }

  _configureBodyView() {
    if (widget.haveUpview == true) {
      return Column(
        children: <Widget>[
          widget.commonWidgetUp,
          Container(
            color: widget.itemBackgroundColor,
            child: new TabBar(
              controller: widget.tabController,
              isScrollable: widget.titleCanScroll,
              indicatorWeight: widget.indicatorHeight,
              indicatorColor: widget.indicateColor,
              labelColor: widget.unSelectColor,
              tabs: widget.paramPages.map((Map myDic) {
                return new Tab(child: GestureDetector(
                  child: Container(
                    child: Text(
                      myDic['text'].toString(),
                      style: TextStyle(
                        color: widget.itemColor,
                        fontSize: widget.itemTitleFont,
                      ),
                    ),
                  ),
                ));
              }).toList(),
            ),
          ),
        ],
      );
    }else{
      return Container(
        color: widget.itemBackgroundColor,
        child: new TabBar(
          controller: widget.tabController,
          isScrollable: widget.titleCanScroll,
          indicatorWeight: widget.indicatorHeight,
          indicatorColor: widget.indicateColor,
          labelColor: widget.unSelectColor,
          tabs: widget.paramPages.map((Map myDic) {
            return new Tab(child: GestureDetector(
              child: Container(
                child: Text(
                  myDic['text'].toString(),
                  style: TextStyle(
                    color: widget.itemColor,
                    fontSize: widget.itemTitleFont,
                  ),
                ),
              ),
            ));
          }).toList(),
        ),
      );
    }
  }
}

